/*
** ###################################################################
**     This code is generated by the Device Initialization Tool.
**     It is overwritten during code generation.
**     USER MODIFICATION ARE PRESERVED ONLY INSIDE INTERRUPT SERVICE ROUTINES
**     OR EXPLICITLY MARKED SECTIONS
**
**     Project   : cartel
**     Processor : MC9S08QE32CLD
**     Version   : Component 01.005, Driver 01.06, CPU db: 3.00.019
**     Datasheet : MC9S08QE32RM Rev. 1 7/2008
**     Date/Time : 14/02/2011, 12:52 p.m.
**     Abstract  :
**         This module contains device initialization code 
**         for selected on-chip peripherals.
**     Contents  :
**         Function "MCU_init" initializes selected peripherals
**
**     Copyright : 1997 - 2009 Freescale Semiconductor, Inc. All Rights Reserved.
**     
**     http      : www.freescale.com
**     mail      : support@freescale.com
** ###################################################################
*/

/* MODULE MCUinit */

#include <MC9S08QE32.h>                /* I/O map for MC9S08QE32CLD */
#include "MCUinit.h"

/* User declarations and definitions */
/*   Code, declarations and definitions here will be preserved during code generation */
/* End of user declarations and definitions */


/*
** ===================================================================
**     Method      :  MCU_init (component MC9S08QE32_44)
**
**     Description :
**         Device initialization code for selected peripherals.
** ===================================================================
*/
void MCU_init(void)
{
  /* ### MC9S08QE32_44 "Cpu" init code ... */
  /*  PE initialization code after reset */

  /* Common initialization of the write once registers */
  /* SOPT1: COPE=0,COPT=1,STOPE=0,BKGDPE=1,RSTPE=0 */
  SOPT1 = 66;                                      
  /* SPMSC1: LVDF=0,LVDACK=0,LVDIE=0,LVDRE=1,LVDSE=1,LVDE=1,BGBE=0 */
  SPMSC1 = 28;                                      
  /* SPMSC2: LPR=0,LPRS=0,LPWUI=0,PPDF=0,PPDACK=0,PPDE=1,PPDC=0 */
  SPMSC2 = 2;                                      
  /* SPMSC3: LVDV=0,LVWV=0,LVWIE=0 */
  SPMSC3 &= (unsigned char)~56;                     
  /*  System clock initialization */
  if (*(unsigned char*far)65455 != 255) { /* Test if the device trim value is stored on the specified address */
    ICSTRM = *(unsigned char*far)65455; /* Initialize ICSTRM register from a non volatile memory */
    ICSSC = (unsigned char)((*(unsigned char*far)65454) & (unsigned char)1); /* Initialize ICSSC register from a non volatile memory */
  }
  /* ICSC1: CLKS=0,RDIV=0,IREFS=1,IRCLKEN=0,IREFSTEN=0 */
  ICSC1 = 4;                           /* Initialization of the ICS control register 1 */
  /* ICSC2: BDIV=0,RANGE=0,HGO=0,LP=0,EREFS=0,ERCLKEN=0,EREFSTEN=0 */
  ICSC2 = 0;                           /* Initialization of the ICS control register 2 */
  while(!ICSSC_IREFST) {               /* Wait until the source of reference clock is internal clock */
  }
  /* ICSSC: DRST_DRS=1,DMX32=1 */
  ICSSC = (ICSSC & (unsigned char)~128) | (unsigned char)96; /* Initialization of the ICS status and control */
  while((ICSSC & 192) != 64) {         /* Wait until the FLL switches to Mid range DCO mode */
  }
  /* SCGC1: TPM3=1,TPM2=1,TPM1=1,ADC=1,IIC=1,SCI2=1,SCI1=1 */
  SCGC1 = 255;                                      
  /* SCGC2: DBG=1,FLS=1,IRQ=1,KBI=1,ACMP=1,RTC=1,SPI=1 */
  SCGC2 = 255;                                      
  /* Common initialization of the CPU registers */
  /* PTASE: PTASE7=0,PTASE6=0,PTASE4=0,PTASE3=0,PTASE2=0,PTASE1=0,PTASE0=0 */
  PTASE &= (unsigned char)~223;                     
  /* PTBSE: PTBSE7=0,PTBSE6=0,PTBSE5=0,PTBSE4=0,PTBSE3=0,PTBSE2=0,PTBSE1=0,PTBSE0=0 */
  PTBSE = 0;                                      
  /* PTCSE: PTCSE7=0,PTCSE6=0,PTCSE5=0,PTCSE4=0,PTCSE3=0,PTCSE2=0,PTCSE1=0,PTCSE0=0 */
  PTCSE = 0;                                      
  /* PTDSE: PTDSE7=0,PTDSE6=0,PTDSE5=0,PTDSE4=0,PTDSE3=0,PTDSE2=0,PTDSE1=0,PTDSE0=0 */
  PTDSE = 0;                                      
  /* PTESE: PTESE7=0,PTESE2=0,PTESE1=0,PTESE0=0 */
  PTESE &= (unsigned char)~135;                     
  /* PTADS: PTADS7=0,PTADS6=0,PTADS5=0,PTADS4=0,PTADS3=0,PTADS2=0,PTADS1=0,PTADS0=0 */
  PTADS = 0;                                      
  /* PTBDS: PTBDS7=0,PTBDS6=0,PTBDS5=0,PTBDS4=0,PTBDS3=0,PTBDS2=0,PTBDS1=0,PTBDS0=0 */
  PTBDS = 0;                                      
  /* PTCDS: PTCDS7=0,PTCDS6=0,PTCDS5=0,PTCDS4=0,PTCDS3=0,PTCDS2=0,PTCDS1=0,PTCDS0=0 */
  PTCDS = 0;                                      
  /* PTDDS: PTDDS7=0,PTDDS6=0,PTDDS5=0,PTDDS4=0,PTDDS3=0,PTDDS2=0,PTDDS1=0,PTDDS0=0 */
  PTDDS = 0;                                      
  /* PTEDS: PTEDS7=0,PTEDS6=0,PTEDS5=0,PTEDS4=0,PTEDS3=0,PTEDS2=0,PTEDS1=0,PTEDS0=0 */
  PTEDS = 0;                                      
  /* ### Init_SCI init code */
  /* SCI2C2: TIE=0,TCIE=0,RIE=0,ILIE=0,TE=0,RE=0,RWU=0,SBK=0 */
  SCI2C2 = 0;                          /* Disable the SCI2 module */
  (void)(SCI2S1 == 0);                 /* Dummy read of the SCI2S1 register to clear flags */
  (void)(SCI2D == 0);                  /* Dummy read of the SCI2D register to clear flags */
  /* SCI2S2: LBKDIF=1,RXEDGIF=1,RXINV=0,RWUID=0,BRK13=0,LBKDE=0,RAF=0 */
  SCI2S2 = 192;                                      
  /* SCI2BDH: LBKDIE=0,RXEDGIE=0,SBR12=0,SBR11=0,SBR10=0,SBR9=0,SBR8=0 */
  SCI2BDH = 0;                                      
  /* SCI2BDL: SBR7=0,SBR6=1,SBR5=1,SBR4=1,SBR3=1,SBR2=0,SBR1=1,SBR0=1 */
  SCI2BDL = 123;                                      
  /* SCI2C1: LOOPS=0,SCISWAI=0,RSRC=0,M=0,WAKE=0,ILT=0,PE=0,PT=0 */
  SCI2C1 = 0;                                      
  /* SCI2C3: R8=0,T8=0,TXDIR=0,TXINV=0,ORIE=0,NEIE=0,FEIE=0,PEIE=0 */
  SCI2C3 = 0;                                      
  /* SCI2C2: TIE=0,TCIE=0,RIE=0,ILIE=0,TE=1,RE=1,RWU=0,SBK=0 */
  SCI2C2 = 12;                                      
  /* ### */
  asm CLI;                             /* Enable interrupts */
} /*MCU_init*/


/*
** ===================================================================
**     Interrupt handler : isrVsci2tx
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void isrVsci2tx(void)
{
  /* Write your interrupt code here ... */

}
/* end of isrVsci2tx */


/*
** ===================================================================
**     Interrupt handler : isrVsci2rx
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void isrVsci2rx(void)
{
  /* Write your interrupt code here ... */

}
/* end of isrVsci2rx */


/*
** ===================================================================
**     Interrupt handler : isrVsci2err
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void isrVsci2err(void)
{
  /* Write your interrupt code here ... */

}
/* end of isrVsci2err */


/*
** ===================================================================
**     Interrupt handler : isrVlvd
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void isrVlvd(void)
{
  /* Write your interrupt code here ... */

}
/* end of isrVlvd */



/* Initialization of the CPU registers in FLASH */

/* NVPROT: FPS7=1,FPS6=1,FPS5=1,FPS4=1,FPS3=1,FPS2=1,FPS1=1,FPDIS=1 */
const unsigned char NVPROT_INIT @0x0000FFBD = 255;

/* NVOPT: KEYEN=0,FNORED=1,SEC01=1,SEC00=0 */
const unsigned char NVOPT_INIT @0x0000FFBF = 126;



extern near void _Startup(void);

/* Interrupt vector table */
#ifndef UNASSIGNED_ISR
  #define UNASSIGNED_ISR ((void(*near const)(void)) 0xFFFF) /* unassigned interrupt service routine */
#endif

void (* near const _vect[])(void) @0xFFC0 = { /* Interrupt vector table */
         UNASSIGNED_ISR,               /* Int.no. 31 Vtpm3ovf (at FFC0)              Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 30 Vtpm3ch5 (at FFC2)              Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 29 Vtpm3ch4 (at FFC4)              Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 28 Vtpm3ch3 (at FFC6)              Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 27 Vtpm3ch2 (at FFC8)              Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 26 Vtpm3ch1 (at FFCA)              Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 25 Vtpm3ch0 (at FFCC)              Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 24 Vrtc (at FFCE)                  Unassigned */
         isrVsci2tx,                   /* Int.no. 23 Vsci2tx (at FFD0)               Used */
         isrVsci2rx,                   /* Int.no. 22 Vsci2rx (at FFD2)               Used */
         isrVsci2err,                  /* Int.no. 21 Vsci2err (at FFD4)              Used */
         UNASSIGNED_ISR,               /* Int.no. 20 Vacmpx (at FFD6)                Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 19 Vadc (at FFD8)                  Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 18 Vkeyboard (at FFDA)             Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 17 Viic (at FFDC)                  Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 16 Vsci1tx (at FFDE)               Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 15 Vsci1rx (at FFE0)               Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 14 Vsci1err (at FFE2)              Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 13 Vspi (at FFE4)                  Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 12 VReserved12 (at FFE6)           Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 11 Vtpm2ovf (at FFE8)              Unassigned */
         UNASSIGNED_ISR,               /* Int.no. 10 Vtpm2ch2 (at FFEA)              Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  9 Vtpm2ch1 (at FFEC)              Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  8 Vtpm2ch0 (at FFEE)              Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  7 Vtpm1ovf (at FFF0)              Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  6 Vtpm1ch2 (at FFF2)              Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  5 Vtpm1ch1 (at FFF4)              Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  4 Vtpm1ch0 (at FFF6)              Unassigned */
         isrVlvd,                      /* Int.no.  3 Vlvd (at FFF8)                  Used */
         UNASSIGNED_ISR,               /* Int.no.  2 Virq (at FFFA)                  Unassigned */
         UNASSIGNED_ISR,               /* Int.no.  1 Vswi (at FFFC)                  Unassigned */
         _Startup                      /* Int.no.  0 Vreset (at FFFE)                Reset vector */
};




/* END MCUinit */

/*
** ###################################################################
**
**     This file was created by Processor Expert 3.07 [04.34]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
